import Query from './query';
import { FilterValue } from '../models/types/filterValue';
declare class Filter {
    lessThan: (value: FilterValue) => Query;
    lessThanOrEqual: (value: FilterValue) => Query;
    greaterThan: (value: FilterValue) => Query;
    greaterThanOrEqual: (value: FilterValue) => Query;
    private _query;
    private _columnName;
    private _expressionParts;
    constructor(query: Query, columnName: string);
    lt(value: FilterValue): Query;
    lte(value: FilterValue): Query;
    gt(value: FilterValue): Query;
    gte(value: FilterValue): Query;
    isNull(): Query;
    isNotNull(): Query;
    equals(value: FilterValue): Query;
    notEquals(value: FilterValue): Query;
    between(start: FilterValue, end: FilterValue): Query;
    like(value: FilterValue): Query;
    notLike(value: FilterValue): Query;
    contains(value: FilterValue): Query;
    notContains(value: FilterValue): Query;
    in(values: FilterValue[]): Query;
    notIn(values: FilterValue[]): Query;
    query(): string;
}
export default Filter;
